# -*- coding: utf-8 -*-
import gtk, pango, gobject
import os, marshal, base64

import WIDGET, child, GConf, Conf, func, i18n

_ = i18n.gettext()

class TabList (WIDGET.WIDGET) :

	STATE = None
	LIST_TAB = list()
	NOTEBOOK = None

	CURRENT_PAGE = int()

	BOX = None

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")

		self.STATE = kwargs["state"]
		self.LIST_TAB = self.STATE.get_value("tab-list")
		self.NOTEBOOK = self.STATE.get_value("notebook")

		# get current page.
		self.CURRENT_PAGE = self.NOTEBOOK.get_current_page()

		WIDGET.WIDGET.__init__(self, "tablist", None)

		self.__create_list()

		# set label.
		self.WIDGET_SELF.set_title(_("List Tabs."))
		__label = self.xml.get_widget("label101")
		__label.set_label(_("<b>Tab List - Select One.</b>"))

	def __create_list (self) :
		self.BOX = self.xml.get_widget("vbox19")
		__n = 0
		for i in self.LIST_TAB :
			# get the name of each tab.
			__t = i.Child.CHILD_TYPE
			if __t == child.TYPE_TERMINAL :
				__type = "terminal"
				__label = i.Child.DIRECTORY
			elif __t == child.TYPE_EXTERNAL_COMMAND :
				__type = "external_command"
				__label = i.Child.EXTERNAL_COMMAND
			elif __t == child.TYPE_VIM :
				__type = "vim"
				__label = i.Child.FILENAME
			elif __t == child.TYPE_GVIM :
				__type = "gvim"
				__label = i.Child.FILENAME
			else :
				return

			self.append_item(__type, __label, __n + 1)
			__n += 1

		__1st = self.BOX.get_children()[self.CURRENT_PAGE]
		__1st.set_active(True)
		__1st.grab_focus()

	def append_item (self, type, label, seq) :
		__label = gtk.Label(" %d : %s" % (seq, label))
		__image = self.get_icon(type)
		__label.show()
		__image.show()

		__box = gtk.HBox()
		__box.pack_start(__image, expand=False, fill=False)
		__box.pack_start(__label, expand=False, fill=False)
		__box.set_property("homogeneous", False)
		__box.show()

		__button = gtk.ToggleButton()
		__button.add(__box)
		__button.set_data("seq", seq)
		__button.show()

		__button.connect("focus_out_event", self.on_unselect_item)
		__button.connect("focus_in_event", self.on_select_item)
		__button.connect("event", self.on_select_event)

		self.BOX.pack_start(__button)

	def on_unselect_item (self, widget, event) :
		widget.set_active(False)

	def on_select_item (self, widget, event) :
		widget.set_active(True)

	def on_select_event (self, widget, event) :
		try :
			event.keyval
		except AttributeError :
			return

		if event.keyval == 65293 :
			num_page = widget.get_data("seq") - 1
			self.NOTEBOOK.set_current_page(num_page)

	def get_icon (self, type) :

		if type == "category" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "category.png")
		elif type == "terminal" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "terminal.png")
		elif type == "external_command" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "external-command.png")
		elif type == "vim" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "vim.png")
		elif type == "gvim" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "gvim.png")

		# create category icon image
		__p = gtk.gdk.pixbuf_new_from_file_at_size(__path, 50, 50)
		__i = gtk.Image()
		__i.set_from_pixbuf(__p)

		return __i

class ExternalCommand (WIDGET.WIDGET) :

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE = None
	STATE = None
	CALLBACK_FUNCTIONS = dict()
	TREEVIEW_LAST_COMMAND = None

	GCONF_CLIENT = None

	LIST_STORED = list()

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("completion_liststore") :
			raise ValueError, _("completion_liststore must be included.")
		else :
			self.LISTSTORE = kwargs["completion_liststore"]

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		handler = { \
			"on_ok"	: self.on_ok, \
			"on_add_command"	: self.on_add_command, \
			"on_remove_command"	: self.on_remove_command, \
		}

		WIDGET.WIDGET.__init__( \
			self, "external_command", None, handler)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		self.BOX_LAST_COMMAND = self.xml.get_widget("vbox17")
		# by default, hide it.
		#self.BOX_LAST_COMMAND.hide()

		__label = self.xml.get_widget("label92")
		__label.set_label(_("Run Command"))

		self.ENTRY_EXTERNAL_COMMAND = self.xml.get_widget("comboboxentry1")
		__completion = gtk.EntryCompletion()
		self.ENTRY_EXTERNAL_COMMAND.child.set_completion(__completion)
		self.ENTRY_EXTERNAL_COMMAND.child.grab_focus()
		self.ENTRY_EXTERNAL_COMMAND.child.connect("activate", self.on_ok)
		self.ENTRY_EXTERNAL_COMMAND.child.connect( \
			"changed", self.on_changed_entry)

		__completion.set_model(self.LISTSTORE)
		__completion.set_text_column(0)

		# saved command list.
		self.EXPANDER = self.xml.get_widget("expander1")
		self.EXPANDER.connect("notify::expanded", self.expander_callback)
		self.WIDGET_SELF.set_title(_("Run Command"))

		# buttons
		self.BUTTON_ADD = self.xml.get_widget("button_add")
		self.BUTTON_ADD.set_property("sensitive", False)
		self.BUTTON_REMOVE = self.xml.get_widget("button_remove")
		self.BUTTON_REMOVE.set_property("sensitive", False)

		__label = self.xml.get_widget("label97")
		__label0 = self.xml.get_widget("label98")
		__label.set_label(_("Add"))
		__label0.set_label(_("Remove"))

		__label = self.xml.get_widget("label96")
		__label.set_label(_("Saved commands."))

		self.__load_list()
		self.__create_treeview()

	def __load_list (self) :

		# get the stored list of external command list.
		__data = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["external-command-list"]["key"])

		__data0 = base64.decodestring(__data)
		__data1 = marshal.loads(__data0)

		if type(__data1) is list :
			self.LIST_STORED = __data1

	def __store_list (self) :
		__data = marshal.dumps(self.LIST_STORED)
		__data0 = base64.encodestring(__data)

		self.GCONF_CLIENT.set_value("string", \
			Conf.SCHEMA["external-command-list"]["key"], \
			__data0 \
		)

	def __store_item (self, command) :
		self.LIST_STORED.append(command)
		self.__store_list()

	def on_changed_entry (self, widget) :
		__d = widget.get_text().strip()

		if len(__d) < 1 :
			self.BUTTON_ADD.set_property("sensitive", False)
		else :
			self.BUTTON_ADD.set_property("sensitive", True)

	def __create_treeview (self) :
		self.TREEVIEW_LAST_COMMAND = self.xml.get_widget("treeview3")
		self.TREEVIEW_LAST_COMMAND.set_headers_visible(False)

		# connect signal
		self.TREEVIEW_LAST_COMMAND.connect( \
			"cursor-changed", self.on_select_command)

		# create a CellRenderers to render the data
		self.tvcolumn = gtk.TreeViewColumn("")
		self.tvcolumn.set_expand(True)
		self.tvcolumn.set_sort_column_id(0)

		self.LISTSTORE = gtk.ListStore(str)
		self.TREEVIEW_LAST_COMMAND.set_model(self.LISTSTORE)
		self.TREEVIEW_LAST_COMMAND.append_column(self.tvcolumn)

		# add the cells to the columns - 2 in the first
		self.cell = gtk.CellRendererText()
		self.tvcolumn.pack_start(self.cell, True)
		self.tvcolumn.set_attributes(self.cell, text=0)

		self.TREEVIEW_LAST_COMMAND.set_reorderable(True)

		for i in self.LIST_STORED :
			print i
			self.__append_command(i)

	def __append_command (self, command) :
		if not command.strip() : return

		self.LISTSTORE.append(("%s" % command,))
		return

	def on_select_command (self, widget) :
		__tree_selection = self.TREEVIEW_LAST_COMMAND.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__value = self.LISTSTORE.get_value(__tree_iter, 0)
		except TypeError :
			return

		self.ENTRY_EXTERNAL_COMMAND.child.set_text(__value)
		self.BUTTON_REMOVE.set_property("sensitive", True)

	def on_add_command (self, widget) :
		__c = self.ENTRY_EXTERNAL_COMMAND.child.get_text()
		if len(__c.strip()) < 1 : return

		self.__append_command(__c)
		# after add in tree, make entry to be blank.
		self.ENTRY_EXTERNAL_COMMAND.child.set_text("")

		self.__store_item(__c)

	def on_remove_command (self, widget) :
		__tree_selection = self.TREEVIEW_LAST_COMMAND.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__path = self.LISTSTORE.get_path(__tree_iter)
		except TypeError :
			return

		self.LISTSTORE.remove(__tree_iter)
		self.ENTRY_EXTERNAL_COMMAND.child.set_text("")

		del(self.LIST_STORED[__path[0]])
		self.__store_list()

	def expander_callback(self, expander, param_spec, user_data=None):
		if expander.get_expanded():
			self.BOX_LAST_COMMAND.show()
			self.WIDGET_SELF.set_property("resizable", True)
		else:
			self.BOX_LAST_COMMAND.hide()
			self.WIDGET_SELF.set_property("resizable", False)

	def on_ok (self, widget) :
		__c = self.ENTRY_EXTERNAL_COMMAND.child.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE.append([__c, ])
		__func = self.CALLBACK_FUNCTIONS["addPage"]
		__func("external_command", external_command=__c.strip())

		self.on_close(widget)

class AskCloseAllTabDialog (WIDGET.WIDGET) :

	GCONF_CLIENT = None
	LIST_TAB = list()
	NOTEBOOK = None
	STATE = None

	def __init__ (self, ROOT, state) :
		handler = { \
			"on_ok"	: self.on_ok, \
			"on_cancel" : self.on_close, \
		}

		WIDGET.WIDGET.__init__( \
			self, "quit", ROOT, handler)

		self.WIDGET_SELF.set_title(_("Quit"))

		self.STATE = state

		if self.STATE.DATA.has_key("tab-list") :
			self.LIST_TAB = self.STATE.DATA["tab-list"]

		if self.STATE.DATA.has_key("notebook") :
			self.NOTEBOOK = self.STATE.DATA["notebook"]

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		__label = self.xml.get_widget("label87")
		__label.set_label( \
_("Quit VEE.\nAll the opened tab will be closed."))

	def on_ok (self, widget) :
		self.rememberGememetry()
		#self.removeAllTab()

		gtk.main_quit()

		return True

	def rememberGememetry (self) :
		# save the latest window geometry.
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])
		__wh0 = [ int(i) for i in __wh.split(",")]

		(x, y) = self.WIDGET_ROOT.get_position()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["latest-window-geometry"]["key"], \
			"%d,%d,%d,%d" % (__wh0[0], __wh0[1], x, y) \
		)

	def removeAllTab (self) :
		ALL_REMOVED = True

		# try to close all the tab.
		_n = self.NOTEBOOK.get_n_pages() - 1
		for i in range(_n) :
			try :
				ch = self.LIST_TAB[i]
			except :
				break

			try :
				exit_method = getattr(ch.Child, "exit")
			except AttributeError :
				pass
			else :
				ch.Child.exit()

				if not ch.Child.IS_REMOVED :
					ALL_REMOVED = False
					break

		if ALL_REMOVED : print "all removed"
		#gtk.main_quit()

class NoValidCommand (WIDGET.WIDGET) :

	def __init__ (self, command=str()) :
		WIDGET.WIDGET.__init__(self, "error")

		self.WIDGET_SELF.set_title(_("This command does not exist. Check it out."))

		if command.strip() :
			__label = self.xml.get_widget("label90")
			__label.set_label( \
				_("\n'%s' does not exist. Check it.\n\n") % command \
			)

class FileSelectionDialog (WIDGET.WIDGET) :

	comboSetChild = "vim"
	CALLBACK_FUNCTIONS = dict()
	STATE = None

	NOTEBOOK = None

	CHILD_VIM = 0
	CHILD_GVIM = 1

	PAGE_FILE = 0
	PAGE_DIRECTORY = 1

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		handler = { \
			"on_open"	: self.on_open, \
			"on_cancel" : self.on_close, \
		}

		WIDGET.WIDGET.__init__( \
			self, "filechooserdialog", None, handler)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		self.NOTEBOOK = self.xml.get_widget("notebook")

		# get the directory path, which was opened latest.
		__path = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["last-directory-path-in-fileselectdialog"]["key"])
		if not __path.strip() : __path = os.getenv("HOME")

		self.ChooserFile = self.xml.get_widget("filechooserwidget2")
		self.ChooserDirectory = self.xml.get_widget("filechooserwidget3")

		self.ChooserFile.set_current_folder(__path)

		self.comboSetChild = self.xml.get_widget("combobox2")

		self.comboSetChild.insert_text(self.CHILD_VIM, _("Open In VIM"))
		self.comboSetChild.insert_text(self.CHILD_GVIM, \
			_("Open In GVIM"))
		self.comboSetChild.set_active(self.CHILD_VIM)

		__checkbox_openInThisPage = self.xml.get_widget("checkbutton16")
		__checkbox_openInThisPage.set_label( \
			_("Open this _file(s) in current tab."))

	def on_open (self, widget) :
		__current = self.NOTEBOOK.get_current_page()

		if __current == self.PAGE_FILE :
			self.on_open_file()
		elif __current == self.PAGE_DIRECTORY :
			self.on_open_directory()
		else :
			print "What on earth!!!"
			pass

	def on_open_directory (self) :
		__directory = self.ChooserDirectory.get_filename()

		__func = self.CALLBACK_FUNCTIONS["addPage"]
		__func("terminal", directory=__directory)
		self.on_close(True)

	def on_open_file (self) :

		file_selected = list()
		if self.ChooserFile.get_select_multiple() :
			file_selected = self.ChooserFile.get_filenames()
		else :
			file_selected.append(self.ChooserFile.get_filename())

		__b = self.xml.get_widget("checkbutton16")
		openInThisPage = __b.get_active()

		# save the current directory to gconf.
		self.GCONF_CLIENT.set_value( \
			"string",\
			Conf.SCHEMA["last-directory-path-in-fileselectdialog"]["key"], \
			os.path.dirname(file_selected[0]) \
		)

		__func = self.CALLBACK_FUNCTIONS["addPage"]
		for i in file_selected :
			if os.path.isdir(i) : continue

			if not openInThisPage :
				__type_child = self.comboSetChild.get_active()
				if __type_child == self.CHILD_VIM :
					childname = "vim"
				elif __type_child == self.CHILD_GVIM :
					childname = "gvim"
				else :
					pass

				__func(childname, filename=i)
			else :
				__current_page = \
					self.STATE.DATA["notebook"].get_current_page()

				__child_type = \
					self.STATE.DATA["tab-list"][__current_page].Child.CHILD_TYPE

				if __child_type == child.TYPE_GVIM :
					childname = "gvim"
				elif __child_type == child.TYPE_VIM :
					childname = "vim"
				else :
					pass

				__func( \
					childname, filename=i, openInThisPage=openInThisPage)

		self.on_close(True)

class About (WIDGET.WIDGET) :

	def __init__ (self) :
		WIDGET.WIDGET.__init__(self, "about")

	def on_ok (self, widget) :
		self.on_close(widget)

class Preference (WIDGET.WIDGET) :

	GCONF_CLIENT = None

	FONT_DEFAULT_SYSTEM = str()

	def __init__ (self) :

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		handler = { \
			"on_use_system_font" : self.on_use_system_font, \
			"on_font_set_vim" : self.on_font_set_vim, \
			"on_font_set_terminal" : self.on_font_set_terminal, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_bookmark" : self.on_toggle_bookmark, \
			"on_change_vim" : self.on_change_vim, \
			"on_change_gvim" : self.on_change_gvim, \
			"on_change_terminal" : self.on_change_terminal, \
			"on_change_max_scrollline" : self.on_change_max_scrollline, \
		}

		WIDGET.WIDGET.__init__(self, "preferences", None, handler)

		############################################################
		# get widget
		__widget_font_vim = self.xml.get_widget("fontbutton3")
		__widget_font_terminal = self.xml.get_widget("fontbutton4")
		__widget_font_system_default = self.xml.get_widget("checkbutton12")
		__checkbutton_hide_menubar = self.xml.get_widget("checkbutton13")
		__checkbutton_hide_toolbar = self.xml.get_widget("checkbutton14")
		__checkbutton_hide_bookmark = self.xml.get_widget("checkbutton15")
		__widget_command_vim = self.xml.get_widget("entry13")
		__widget_command_gvim = self.xml.get_widget("entry16")
		__widget_command_terminal = self.xml.get_widget("entry14")
		__widget_max_scrollline = self.xml.get_widget("spinbutton1")
		__label_font_VIM = self.xml.get_widget("label75")
		__label_font_Terminal = self.xml.get_widget("label76")

		__label_tab0 = self.xml.get_widget("label51")
		__label_tab1 = self.xml.get_widget("label59")
		__label_tab2 = self.xml.get_widget("label88")

		__label_tab3 = self.xml.get_widget("label77")
		__label_tab4 = self.xml.get_widget("label78")
		__label_tab5 = self.xml.get_widget("label91")

		__label_tab6 = self.xml.get_widget("label50")
		__label_tab7 = self.xml.get_widget("label58")
		__label_tab8 = self.xml.get_widget("label89")

		__label = self.xml.get_widget("label102")
		__label.set_label(_("<b>Fonts</b>"))
		__label = self.xml.get_widget("label103")
		__label.set_label(_("<b>Colors</b>"))
		__label = self.xml.get_widget("label104")
		__label.set_label(_("Foreground : "))
		__label = self.xml.get_widget("label105")
		__label.set_label(_("Background : "))
		__label = self.xml.get_widget("label106")
		__label.set_label(_("Dim : "))
		__label = self.xml.get_widget("label107")
		__label.set_label(_("Highlight : "))
		__label = self.xml.get_widget("label108")
		__label.set_label(_("Cursor : "))

		# set label
		__checkbutton_hide_menubar.set_label(_("Show menubar"))
		__checkbutton_hide_toolbar.set_label(_("Show toolbar"))
		__checkbutton_hide_bookmark.set_label(_("Show bookmark"))
		__widget_font_system_default.set_label( \
			_("Use gnome default terminal font."))
		__label_font_VIM.set_label(_("VIM Font : "))
		__label_font_Terminal.set_label(_("Terminal Font : "))
		__label_tab0.set_label(_("Main"))
		__label_tab1.set_label(_("Command"))
		__label_tab2.set_label(_("Terminal"))
		__label_tab3.set_label(_("VIM Command : "))
		__label_tab4.set_label(_("Terminal Command : "))
		__label_tab5.set_label(_("GVIM Command : "))
		__label_tab6.set_label(_("<b>Main</b>"))
		__label_tab7.set_label(_("<b>Command</b>"))
		__label_tab8.set_label(_("Maximum line number to scroll : "))

		# set default system font.
		self.FONT_DEFAULT_SYSTEM = self.GCONF_CLIENT.get_value( \
				Conf.GLOBAL_FONT_SYSTEM_DEFAULT)

		# set font name
		__fontname_vim = self.GCONF_CLIENT.get_value(Conf.SCHEMA["font-vim"]["key"])
		__fontname_terminal = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["font-terminal"]["key"])

		if __fontname_vim :
			__widget_font_vim.set_font_name(__fontname_vim)

		if __fontname_terminal :
			__widget_font_terminal.set_font_name(__fontname_terminal)

		__use_system_default_font = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["use-system-default-font"]["key"])

		if __use_system_default_font :
			__widget_font_vim.set_sensitive(False)
			__widget_font_terminal.set_sensitive(False)
			__widget_font_system_default.set_active(True)
		else :
			__widget_font_system_default.set_active(False)

		# show/hide menubar, toolbar, bookmark
		__show_menubar = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-menubar"]["key"])
		__checkbutton_hide_menubar.set_active(__show_menubar)

		__show_toolbar = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-toolbar"]["key"])
		__checkbutton_hide_toolbar.set_active(__show_toolbar)

		__show_bookmark = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-bookmark"]["key"])
		__checkbutton_hide_bookmark.set_active(__show_bookmark)

		__command_vim = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-vim"]["key"])
		__command_gvim = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-gvim"]["key"])
		__command_terminal = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-terminal"]["key"])

		__widget_command_vim.set_text(__command_vim)
		__widget_command_gvim.set_text(__command_gvim)
		__widget_command_terminal.set_text(__command_terminal)

		# max scrollable line
		__value_max_scrollline = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["max-scrollline"]["key"])

		__widget_max_scrollline.set_value(int(__value_max_scrollline))

		# set color
		__colorbutton_foreground = self.xml.get_widget("colorbutton1")
		__colorbutton_foreground.connect( \
			"color-set", self.on_color_changed, "foreground")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-foreground"]["key"])
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_foreground.set_color(__gdkColor)

		__colorbutton_background = self.xml.get_widget("colorbutton2")
		__colorbutton_background.connect( \
			"color-set", self.on_color_changed, "background")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-background"]["key"])
		__gdkColor = func.str_to_color(__c, "black")
		__colorbutton_background.set_color(__gdkColor)

		__colorbutton_dim = self.xml.get_widget("colorbutton3")
		__colorbutton_dim.connect( \
			"color-set", self.on_color_changed, "dim")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-dim"]["key"])
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_dim.set_color(__gdkColor)

		__colorbutton_highlight = self.xml.get_widget("colorbutton4")
		__colorbutton_highlight.connect( \
			"color-set", self.on_color_changed, "highlight")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-highlight"]["key"])
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_highlight.set_color(__gdkColor)

		__colorbutton_cursor = self.xml.get_widget("colorbutton5")
		__colorbutton_cursor.connect( \
			"color-set", self.on_color_changed, "cursor")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-cursor"]["key"])
		__gdkColor = func.str_to_color(__c, "red")
		__colorbutton_cursor.set_color(__gdkColor)

	def on_color_changed (self, widget, type) :
		__c = func.color_to_str(widget.get_color())
		self.GCONF_CLIENT.set_value( \
			"string", \
			Conf.SCHEMA["color-%s" % (type)]["key"], \
			__c
		)

	def on_change_terminal (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-terminal"]["key"], \
			widget.get_text())

	def on_change_vim (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-vim"]["key"], \
			widget.get_text())

	def on_change_gvim (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-gvim"]["key"], \
			widget.get_text())

	def on_toggle_menubar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-menubar"]["key"], __is_activated)

	def on_toggle_toolbar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-toolbar"]["key"], __is_activated)

	def on_toggle_bookmark (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-bookmark"]["key"], __is_activated)

	def on_font_set_vim (self, widget) :
		__font_name = widget.get_font_name()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["font-vim"]["key"], __font_name)

	def on_font_set_terminal (self, widget) :
		__font_name = widget.get_font_name()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["font-terminal"]["key"], __font_name)

	def on_use_system_font (self, widget) :

		__checkbutton = self.xml.get_widget("checkbutton12")

		__buttonFontVIM = self.xml.get_widget("fontbutton3")
		__buttonFontTerminal = self.xml.get_widget("fontbutton4")

		__labelFontVIM = self.xml.get_widget("label75")
		__labelFontTerminal = self.xml.get_widget("label76")

		if __checkbutton.get_active() :

			__buttonFontTerminal.set_sensitive(False)
			__buttonFontVIM.set_sensitive(False)

			__labelFontTerminal.set_sensitive(False)
			__labelFontVIM.set_sensitive(False)

			self.GCONF_CLIENT.set_value( \
				"bool", Conf.SCHEMA["use-system-default-font"]["key"], True)
		else :
			self.GCONF_CLIENT.set_value( \
				"bool", Conf.SCHEMA["use-system-default-font"]["key"], False)

			__buttonFontTerminal.set_sensitive(True)
			__buttonFontVIM.set_sensitive(True)

			__labelFontTerminal.set_sensitive(True)
			__labelFontVIM.set_sensitive(True)

	def on_change_max_scrollline (self, widget) :
		__value = widget.get_value()

		self.GCONF_CLIENT.set_value( \
			"int", Conf.SCHEMA["max-scrollline"]["key"], int(__value))

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Dialog.py"


