#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys, os, shutil, sha, time

import pygtk
pygtk.require("2.0")

import i18n
_ = i18n.gettext()

try :
	import gtk
	import gtk.glade
	import gobject
	import pango
	import gconf
except :
	print _("You need to install pygtk or GTKv2.")
	sys.exit(1)

import Options, TAB, WIDGET, Label, State, \
	Dialog, GConf, Conf, Menu, child, func, Panel

class main (WIDGET.WIDGET) :

	LIST_TAB = list()
	NOTEBOOK = None

	STATE = None
	IS_LOGO = True

	Toolbar = None
	Menubar = None

	ARGS_OPTIONS = dict()
	ARGS_ARGS = list()

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE_EXTERNAL_COMMAND = None

	LIST_TAB_SHORTCUT = dict()

	def __init__ (self, **kwargs) :

		self.STATE = State.State()

		# parse arguments and options.
		if kwargs.has_key("args_options") :
			self.ARGS_OPTIONS = kwargs["args_options"]

		if kwargs.has_key("args_args") :
			self.ARGS_ARGS = kwargs["args_args"]

		handler = { \
			# etc.
			"on_new_vee" : self.on_new_vee, \
			\
			"on_insert_vim" : self.on_insert_vim, \
			"on_insert_gvim" : self.on_insert_gvim, \
			"on_insert_terminal" : self.on_insert_terminal, \
			"on_external_command" : self.on_external_command, \
			\
			"on_open_file_dialog" : self.on_fileSelectionDialog, \
			"on_external_command_dialog" : \
				self.on_external_command_dialog, \
			\
			"on_font_select" : self.on_fontSelectionDialog, \
			"on_font_increase" : self.on_font_increase, \
			"on_font_decrease" : self.on_font_decrease, \
			\
			"on_next_tab" : self.on_next_tab, \
			"on_previous_tab" : self.on_previous_tab, \
			\
			"on_remove_page" : self.on_remove_page, \
			\
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_toggle_bookmark" : self.on_toggle_bookmark, \
			\
			"on_preference" : self.on_preference, \
			"on_about" : self.on_about, \
			\
			"on_quit_all" : self.on_quit_all, \
		}

		# preference
		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		WIDGET.WIDGET.__init__(self, "vee", None, handler)

		self.WIDGET_SELF.set_title(_("vee"))

		# window size matters.
		self.WIDGET_SELF.set_gravity(gtk.gdk.GRAVITY_STATIC)
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])

		__wh0 = [ int(i) for i in __wh.split(",")]

		# resize() and set_size_request will change the window size, but
		# set_size_request keep the window from being smaller.
		self.WIDGET_SELF.resize(__wh0[0], __wh0[1])

		self.WIDGET_SELF.connect( \
			"size_request", self.on_window_size_changed)

		# create accelerator group.
		self.AccelGrpGlobal = gtk.AccelGroup()
		self.AccelGrpWhenHideMenubar = gtk.AccelGroup()

		# register global keyboard shortcut.
		self.WIDGET_SELF.add_accel_group(self.AccelGrpGlobal)
		self.WIDGET_SELF.add_accel_group(self.AccelGrpWhenHideMenubar)

		self.__activate_accelerator( \
			self.AccelGrpGlobal, Conf.KEYBOARD_SHORTCUT_GLOBAL)
		self.__activate_accelerator( \
			self.AccelGrpWhenHideMenubar, \
			Conf.KEYBOARD_SHORTCUT_WHEN_HIDE_MENUBAR)

		self.WIDGET_SELF.set_events(gtk.gdk.KEY_RELEASE)
		self.WIDGET_SELF.add_events(gtk.gdk.KEY_RELEASE)

		# add notification for gconf.
		__state = { \
			"toolbar" : self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR,
			"menubar" : self.ARGS_OPTIONS.ARG_SHOW_MENUBAR,
			"bookmark" : self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK,
		}

		self.STATE.set_value("toggled-toolbar", not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR)
		self.STATE.set_value("toggled-menubar", not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR)
		self.STATE.set_value("toggled-bookmark", not self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK)

		__callback_functions = {"addPage" : self.addPage}
		gconf_notify = GConf.Notify( \
			callback_functions=__callback_functions, \
			state=self.STATE \
		)

		gconf_notify.add()

		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)

		self.NOTEBOOK = self.xml.get_widget("notebook1")
		self.NOTEBOOK.remove_page(0)
		self.NOTEBOOK.popup_disable()
		self.NOTEBOOK.connect_after( \
			"switch-page", self.on_notebook_switch_page)

		# store information into state
		self.STATE.set_value("root-widget", self.WIDGET_SELF)
		self.STATE.set_value("notebook", self.NOTEBOOK)
		self.STATE.set_value("tab-list", self.LIST_TAB)

		# status bar.
		STATUSBAR = Label.Statusbar(self.xml.get_widget("statusbar1"))
		self.STATE.set_value("statusbar", STATUSBAR)

		# set event.
		EventBox_Notebook = self.xml.get_widget("eventbox1")
		EventBox_Notebook.connect("event", self.on_set_background_logo)
		EventBox_Notebook.connect( \
			"key-release-event", self.on_prevent_key_intercept)

		# toolbar and menubar
		self.Toolbar = self.xml.get_widget("toolbar1")

		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-toolbar"]["key"]) :
			self.Toolbar.hide()

		self.Menubar = self.xml.get_widget("hbox1")
		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-menubar"]["key"]) :
			self.Menubar.hide()

		self.PANEL_BOOKMARK = self.xml.get_widget("vbox11")
		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-bookmark"]["key"]) :
			self.PANEL_BOOKMARK.hide()

		self.STATE.set_value("panel-bookmark", self.PANEL_BOOKMARK)
		self.STATE.set_value("toolbar", self.Toolbar)
		self.STATE.set_value("menubar", self.Menubar)

		# external command entry.
		#ENTRY_EXTERNAL_COMMAND = self.xml.get_widget("entry15")
		ENTRY_EXTERNAL_COMMAND = \
			self.xml.get_widget("comboboxentry2").child
		ENTRY_EXTERNAL_COMMAND.connect("activate", self.on_external_command)
		__completion = gtk.EntryCompletion()
		ENTRY_EXTERNAL_COMMAND.set_completion(__completion)
		self.LISTSTORE_EXTERNAL_COMMAND = gtk.ListStore(gobject.TYPE_STRING)
		__completion.set_model(self.LISTSTORE_EXTERNAL_COMMAND)
		__completion.set_text_column(0)

		print "==========================================="
		print _(" Launched.")
		print ""

		if len(self.ARGS_ARGS) > 0 :
			for i in self.ARGS_ARGS :
				self.addPage("vim", filename=i)
		else :
			if self.ARGS_OPTIONS.ARG_START_WITH_VIM :
				self.addPage("vim")
			if self.ARGS_OPTIONS.ARG_START_WITH_TERMINAL :
				self.addPage("terminal")

		if not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR : self.Toolbar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR : self.Menubar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK : self.PANEL_BOOKMARK.hide()

		# activate popup menu
		self.NOTEBOOK.connect( \
			"button-press-event", \
			Menu.on_show_popup_full, \
			self.WIDGET_SELF, \
			self.STATE, \
			__callback_functions, \
			self.LISTSTORE_EXTERNAL_COMMAND \
		)

		###############################################################
		# ACTIVATE dnd.
		self.NOTEBOOK.connect( \
			"drag_data_received", self.on_drag_received)

		self.Menubar.connect( \
			"drag_data_received", self.on_drag_received)

		self.Toolbar.connect( \
			"drag_data_received", self.on_drag_received)

		self.NOTEBOOK.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Menubar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Toolbar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		#########################################################
		# settting for toolbutton.
		__button_gvim = self.xml.get_widget("toolbutton12")

		# hide new window toolbutton.
		__button_new_window = self.xml.get_widget("toolbutton13")
		__button_new_window.hide()
		__button_vim = self.xml.get_widget("toolbutton1")
		__button_terminal = self.xml.get_widget("toolbutton8")
		__openfile_button = self.xml.get_widget("toolbutton5")
		__next_tab_button = self.xml.get_widget("toolbutton9")
		__perv_tab_button = self.xml.get_widget("toolbutton10")
		__command_label = self.xml.get_widget("toolbutton14")
		__command_label.set_label(_("Run Command"))

		# connect signal for toolbutton.
		__button_vim.connect( \
			"drag_data_received", self.on_drag_received_button_vim)
		__button_vim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_gvim.connect( \
			"drag_data_received", self.on_drag_received_button_gvim)
		__button_gvim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_terminal.connect( \
			"drag_data_received", self.on_drag_received_button_terminal)
		__button_terminal.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		# whether gvim button set visible or not.
		__a = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-gvim"]["key"])

		self.STATE.set_value("gvim-button", __button_gvim)
		if len(__a) < 1 : __button_gvim.hide()

		# set label of toolbutton
		__button_gvim.set_label(_("GVIM"))
		__button_vim.set_label(_("VIM"))
		__openfile_button.set_label(_("Open File"))
		__button_terminal.set_label(_("Open Terminal"))
		__next_tab_button.set_label(_("Next Tab"))
		__perv_tab_button.set_label(_("Previous Tab"))

		# connect signal
		self.PANEL_BOOKMARK.connect("hide", self.on_notify_bookmark)
		self.PANEL_BOOKMARK.connect("show", self.on_notify_bookmark)
		# set the label of the bookmark toggle button.
		self.on_notify_bookmark()

		# creating Bookmarks
		self.Bookmarks = Panel.Bookmarks( \
			self.xml, \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	# EVENT HANDLER #####################################################
	def on_new_vee (self, widget) :
		main(args_options=self.ARGS_OPTIONS, args_args=self.ARGS_ARGS)

	def on_prevent_key_intercept (self, parm1, parm2) :
		__n = self.NOTEBOOK.get_current_page()
		try :
			self.LIST_TAB[__n].Child.WIDGET.grab_focus()
		except :
			pass

	def __addAccelKeySwitchTab (self) :
		"""
		그놈 터미널이나 에피파니처럼 Alt+숫자키로 탭이동하는 패치.
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		__c = Conf.LIST_KEYBOARD_SHORTCUT["modifier-switch-tab"]

		num = len(self.LIST_TAB_SHORTCUT)
		__key, __mod = gtk.accelerator_parse(__c[0] % (num + 1))

		if self.LIST_TAB_SHORTCUT.has_key(__key) :
			return
		else :
			self.LIST_TAB_SHORTCUT[__key] = num
			self.AccelGrpGlobal.connect_group(__key, __mod, \
				gtk.ACCEL_VISIBLE, eval(__c[1]))

	def on_notebook_switch_page (self, widget, parm1, parm2) :

		if len(self.LIST_TAB) < 1 : return

		# change window title.
		current_page = self.NOTEBOOK.get_current_page()
		try :
			__title = self.LIST_TAB[current_page].Child.get_title()
		except IndexError :
			return
		else :
			self.set_title(__title)

	def on_drag_received_button_vim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_drag_received_button_gvim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("gvim", filename=__path)

	def on_drag_received_button_terminal \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("terminal", directory=__path)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_quit_all \
			(self, parm1, parm2=None, parm3=None, parm4=None) :
		Dialog.AskCloseAllTabDialog(self.WIDGET_SELF, self.STATE)

		return True

	def on_external_command_dialog (self, widget) :
		__callback_functions = {"addPage" : self.addPage}
		Dialog.ExternalCommand( \
			state=self.STATE, \
			callback_functions=__callback_functions, \
			completion_liststore=self.LISTSTORE_EXTERNAL_COMMAND \
		)

	def on_external_command (self, widget) :
		__c = widget.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			Dialog.NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE_EXTERNAL_COMMAND.append([__c, ])
		self.addPage("external_command", external_command=__c.strip())

		# make this be blank.
		widget.set_text("")

	def on_window_size_changed (self, widget, parm1) :
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])
		__wh0 = [ int(i) for i in __wh.split(",")]

		(w, h) = self.WIDGET_SELF.get_size()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["latest-window-geometry"]["key"], \
			"%d,%d,%d,%d" % (w, h, __wh0[2], __wh0[3]) \
		)

	def on_toggle_menubar (self, widget) :
		if self.Menubar.get_property("visible") :
			self.Menubar.hide()
		else :
			self.Menubar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-menubar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_toggle_toolbar (self, widget) :
		if self.Toolbar.get_property("visible") :
			self.Toolbar.hide()
		else :
			self.Toolbar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-toolbar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_notify_bookmark (self, widget=None) :
		__label = self.xml.get_widget("label93")
		if self.PANEL_BOOKMARK.get_property("visible") :
			__label.set_label(_("Hide Bookmark Panel (Ctrl+Alt+B)"))
		else :
			__label.set_label(_("Show Bookmark Panel (Ctrl+Alt+B)"))

	def on_toggle_bookmark (self, widget) :
		if self.PANEL_BOOKMARK.get_property("visible") :
			self.PANEL_BOOKMARK.hide()
		else :
			self.PANEL_BOOKMARK.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-bookmark")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_set_background_logo (self, parm1, parm2) :

		if self.NOTEBOOK.get_n_pages() < 1 :
			self.addLogo()

	def on_fileSelectionDialog (self, widget) :
		__callback_functions = {"addPage" : self.addPage}

		Dialog.FileSelectionDialog( \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	def on_fontSelectionDialog (self, widget) :
		Dialog.FontSelectionDialog( \
			self.xml, self.LIST_TAB[self.NOTEBOOK.get_current_page()])

	def on_preference (self, widget) :
		Dialog.Preference()

	def on_about (self, widget) :
		Dialog.About()

	def on_insert_gvim (self, widget) :
		self.addPage("gvim")

	def on_insert_vim (self, widget) :
		self.addPage("vim")

	def on_insert_terminal (self, widget) :
		self.addPage("terminal")

	def on_remove_page (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()
		tab = self.LIST_TAB[current_page]
		tab.Child.exit()
		STATUSBAR.clean()

	def on_font_decrease (self, widget) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def on_font_increase (self, widget) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def on_next_tab (self, widget) :
		self.NOTEBOOK.next_page()

	def on_previous_tab (self, widget) :
		self.NOTEBOOK.prev_page()

	def on_change_title (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()

		__title = self.LIST_TAB[current_page].Child.get_title()

		self.set_title(__title)
		self.LIST_TAB[current_page].INSTANCE_LABEL.set_label(__title)

	#------------------------------------------------------------
	# Accel HANDLER
	def ac_show_tab_list (self, widget, parm1, parm2, parm3) :
		if len(self.LIST_TAB) < 1 : return
		Dialog.TabList(state=self.STATE)

	def ac_toggle_bookmark (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.grab_focus()
		if self.PANEL_BOOKMARK.get_property("visible") :
			self.PANEL_BOOKMARK.hide()
		else :
			self.PANEL_BOOKMARK.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-bookmark")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def ac_change_nth_tab (self, parm1, parm2, parm3, parm4) :
		"""
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		self.NOTEBOOK.grab_focus()
		__n = self.LIST_TAB_SHORTCUT[parm3]
		if __n == self.NOTEBOOK.get_current_page() : return

		self.NOTEBOOK.set_current_page(__n)

	def ac_font_decrease (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def ac_font_increase (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def ac_insert_gvim (self, parm1, parm2, parm3, parm4) :
		self.addPage("gvim")

	def ac_insert_vim (self, parm1, parm2, parm3, parm4) :
		self.addPage("vim")

	def ac_insert_terminal (self, parm1, parm2, parm3, parm4) :
		self.addPage("terminal")

	def ac_fileSelectionDialog  (self, parm1, parm2, parm3, parm4) :
		__callback_functions = {"addPage" : self.addPage}
		Dialog.FileSelectionDialog( \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	def ac_next_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_previous_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.prev_page()

	def ac_rotate_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_focus_on_external_command (self, parm1, parm2, parm3, parm4) :
		__entry = self.xml.get_widget("comboboxentry2").child
		__entry.grab_focus()

	#############################################################
	# etc method.
	def set_title (self, strings) :
		self.WIDGET_SELF.set_title(_("%s : VEE") % strings)

	def reset_child (self, type) :
		if len(self.LIST_TAB) < 1 : return

		for i in self.LIST_TAB :
			if i.Child.CHILD_TYPE == type :
				i.Child.reset()

	def __activate_accelerator \
			(self, accel_group, shortcut_tuple=tuple()) :
		if len(shortcut_tuple) < 1 : return False

		for i in shortcut_tuple :
			__o = Conf.LIST_KEYBOARD_SHORTCUT[i]

			if len(__o) < 2 : continue

			__key, __mod = gtk.accelerator_parse(__o[0])
			accel_group.connect_group(__key, __mod, \
				gtk.ACCEL_VISIBLE, eval(__o[1]))

		return True

	def addLogo (self) :

		Logo = gtk.Image()
		Logo.set_from_file(os.path.join(Conf.DIR_PIXMAPS, "vee.png"))
		Logo.show()

		__eventbox = gtk.EventBox()
		__eventbox.add(Logo)
		__eventbox.show()

		tab = TAB.TAB( \
			state=self.STATE, \
			without_closebutton=True)

		tab.addWidget(__eventbox, _("VEE"))
		self.WIDGET_SELF.set_title(_("vee"))

		self.IS_LOGO = True

	def addPage (self, childname, **kwargs) :
		if self.IS_LOGO :
			self.NOTEBOOK.remove_page(0)
			self.IS_LOGO = False

		__tab = child.getTab(childname)
		tab = __tab(self.STATE, **kwargs)

		tab.make()

		self.__addAccelKeySwitchTab()

	def addExample (self) :

		if self.IS_LOGO :
			self.NOTEBOOK.remove_page(0)
			self.IS_LOGO = False

		__example = child.getChild("example")
		example = __example()
		example.make()

		tab = TAB.TAB(state=self.STATE)
		tab.STR_TAB_NAME = _("Example")
		tab.addVTE(example)

		self.LIST_TAB.append(tab)

		# set window title
		#self.set_title(tab.INSTANCE_LABEL.get_label())

		example.WIDGET.connect( \
			"window-title-changed", self.on_change_title)

if __name__ == "__main__" :

	# parse command-line argument.
	__parser = Options.parseVEE()
	(__OPTIONS, __ARGS) = __parser.parse_args()

	# check whether the gconf schema was installed, if not install it.
	if __OPTIONS.ARG_INSTALL_SCHEMA :
		GConf.verify("install schema")
	else :
		GConf.verify()

	app = main(args_options=__OPTIONS, args_args=__ARGS)

	try :
		gtk.main()
	except :
		sys.exit(1)
	else :
		sys.exit(0)

